image: docker:19.03.12
# variables:
#   docker_version: "19.03.12"
services:
  - docker:19.03.12-dind

stages:
- build
- test
- deploy

variables:
  PROJETO: frontend
  TEST_IMAGE: $CI_REGISTRY_USER/$PROJETO:$CI_COMMIT_REF_NAME
  RELEASE_IMAGE: $CI_REGISTRY_USER/$PROJETO:latest
  CLUSTER_NAME: vortx-eks-omAC2biI

#Build e Push da imagem para o Docker Hub
build:
  stage: build
  script:
   - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD
   - docker build --pull -t $TEST_IMAGE .
   - docker push $TEST_IMAGE

test:
  stage: test
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD
    - docker pull $TEST_IMAGE
    - docker tag $TEST_IMAGE $RELEASE_IMAGE
    - docker push $RELEASE_IMAGE

deploy:
  stage: deploy
  image: registry.gitlab.com/gitlab-org/cloud-deploy/aws-base:latest
  script:
    - curl -o kubectl https://amazon-eks.s3.us-west-2.amazonaws.com/1.19.6/2021-01-05/bin/linux/amd64/kubectl
    - curl -o kubectl.sha256 https://amazon-eks.s3.us-west-2.amazonaws.com/1.19.6/2021-01-05/bin/linux/amd64/kubectl.sha256
    - openssl sha1 -sha256 kubectl
    - chmod +x ./kubectl
    - mkdir -p $HOME/bin && cp ./kubectl $HOME/bin/kubectl && export PATH=$PATH:$HOME/bin
    - kubectl version --short --client
    - aws configure set aws_access_key_id $AWS_ACCESS_KEY_ID
    - aws configure set aws_secret_access_key $AWS_SECRET_ACCESS_KEY
    - aws configure set default.region $AWS_DEFAULT_REGION
    - curl -fsSL -o get_helm.sh https://raw.githubusercontent.com/helm/helm/master/scripts/get-helm-3
    - chmod 700 get_helm.sh
    - ./get_helm.sh
    - aws eks --region $AWS_DEFAULT_REGION update-kubeconfig --name $CLUSTER_NAME
    - helm install $PROJETO helm/
  when: manual
  only:
    refs:
    - master
